/* Yash: yet another shell */
/* exec.h: interface to command execution */
/* © 2007-2008 magicant */

/* This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.  */


#ifndef EXEC_H
#define EXEC_H

#include <signal.h>
#include <stdbool.h>
#include <sys/types.h>
#include <sys/select.h>
#include "parser.h"


extern int laststatus;
extern int shellfdmin;

void init_exec(void);
void add_shellfd(int fd);
void remove_shellfd(int fd);
bool is_shellfd(int fd);
void clear_shellfds(void);
void reset_shellfdmin(void);
void exec_statements(STATEMENT *statements, bool finally_exit);
void reset_after_fork(void);
char *exec_and_read(const char *code, bool trimend);


#endif /* EXEC_H */
